#! CRADDON 1
#! NAME YaBB Comments
#! DESCRIPTION Comment your news with YaBB.
#! VERSION 1.0
#! DOC 1

my $addon = new Addon('YaBB Comments');
$addon->checkBuild("29"); 
$addon->isPrivacyCompatible;

$addon->hook('ModifyNews_EditSave_3', 'YaBB_SaveNews');
$addon->hook('SaveNews_1', 'YaBB_SaveNews');
$addon->hook('ModifyNews_Delete_1', 'YaBB_ModifyNews_Delete');
$addon->hook('DisplaySubForm_TopRow','YaBB_DisplaySubForm_TopRow');
$addon->hook('ModifyNews_Edit_TopRow', 'YaBB_ModifyNews_Edit_TopRow');
$addon->hook('ModifyNews_NewColumn_1', 'YaBB_ModifyNews_NewColumn_1');
$addon->hook('ModifyNews_NewColumn_2', 'YaBB_ModifyNews_NewColumn_2');

$addon->addAdvancedSettingHeading('YaBB Addon Settings');
$addon->addAdvancedSetting('YaBB_Path' , 'Url to YaBB' , '(http://www.yoursite.com/cgi-bin/yabb)');
$addon->addAdvancedSetting('YaBB_Abs_Path' , 'Absolute path to YaBB' , 'The absolute path to your YaBB.pl or .cgi (/home/user/html/cgi-bin/yabb)');
$addon->addAdvancedSetting('YaBB_Board_Default', 'YaBB board', 'The default board id of the board your YaBB posts will go into<br>(leave empty to default to not create a thread)');
$addon->addAdvancedSetting('YaBB_User', 'YaBB user', 'The default name that will be displayed as poster in YaBB<br>(max. 18 characters, no spaces or special characters, e.g. News_Reporter)');
$addon->addAdvancedSetting('YaBB_User_Email', 'YaBB email', 'The default posters email address');
$addon->addAdvancedSetting('YaBB_Del_Col_Default', 'YaBB thread delete column default', 'Default value for thread delete selection on Modify News page.<br>(Thread will only be deleted if the newsitem is also deleted)','yn');


NeedCFG();
require "cruser.pl";

if(!$fieldDB{'CustomField_YaBB_ID'})
	{	
	$addon->addNewsField('CustomField_YaBB_ID', '1', 'YaBB ID#');
	}

if(!$fieldDB{'CustomField_YaBB_Board'})
	{
	$addon->addNewsField('CustomField_YaBB_Board', '3', 'YaBB Board');
	}

sub YaBB_ModifyNews_Edit_TopRow
	{
	if ($CustomField_YaBB_Board eq "")
		{
		&YaBB_DisplaySubForm_TopRow;
		}
	}

sub YaBB_ModifyNews_NewColumn_1
	{
	if ($ColCount % 2) 
		{
		print q~<td class="yellowbg">~;
		} 
	else 
		{
		print q~<td class="lightgbg">~;
		}
	print qq~<div align="center"><b>Del.Thread</b></div></td>~;
	$ColCount++;
	}

sub YaBB_ModifyNews_NewColumn_2
	{
	if ($ColCount % 2) 
		{
		print q~<td class="navlink"><div align="center">~;
		}
	else 
		{
		print q~<td class="lightgbg"><div align="center" class="footnote">~;
		}
	if ($CustomField_YaBB_ID && $CustomField_YaBB_Board)
		{
		if ($CConfig{'YaBB_Del_Col_Default'})
			{
			print qq~<input type="checkbox" value="delete" checked name="YaBB_Del-$newsid">~;
			}
		else
			{
			print qq~<input type="checkbox" value="delete" name="YaBB_Del-$newsid">~;
			}
		}
	else
		{
		print "&nbsp;";
		}
	print '</div></td>';
	$ColCount++;
	}

sub YaBB_DisplaySubForm_TopRow
	{
	my ($line, $YaBB_Category);
	print qq~\n<tr><td width="30%" class="fieldtitle" valign="top"><div align="right">YaBB Board:</div></td><td width="70%"><select name="CustomField_YaBB_Board">\n~;
	if (!($CConfig{'YaBB_Board_Default'}))
		{
		print qq~<option value="" selected>None</option>\n~;
		}
	else
		{
		print qq~<option value="">None</option>\n~;
		}
	open(YABB_FILE, "<$CConfig{'YaBB_Abs_Path'}/Variables/cat.txt") || $addon->fatalError("501 An error has occured!: Unable to open cat.txt");
	if ($UseFlock) 
		{
		flock(YABB_FILE, 2) || $addon->fatalError("Could not obtain an exclusive lock on file cat.txt"); 
		}
	my @YaBB_Categories = <YABB_FILE>;
	close(YABB_FILE);
	foreach $YaBB_Category (@YaBB_Categories) 
		{
		chomp $YaBB_Category;
		open(YABB_FILE, "<$CConfig{'YaBB_Abs_Path'}/Boards/$YaBB_Category.cat" || $addon->fatalError("502 An error has occured!: Unable to open $YaBB_Category.cat"));
		if ($UseFlock) 
			{
			flock(YABB_FILE, 2) || $addon->fatalError("Could not obtain an exclusive lock on file $YaBB_Category.cat"); 
			}
		my $YaBB_tmp1 = <YABB_FILE>;
		$YaBB_tmp1 = <YABB_FILE>;
		while( $line = <YABB_FILE> )
			{
			chomp $line;
			if (($line eq $CConfig{'YaBB_Board_Default'}) && ($CConfig{'YaBB_Board_Default'} ne ""))
				{
				print qq~<option value="$line" selected>$line</option>\n~;
				}
			else
				{
				print qq~<option value="$line">$line</option>\n~;
				}
			}
		close(YABB_FILE);
		}
	print qq~</select></td></tr>\n~;
	}

sub YaBB_SaveNews
	{
	if ($CustomField_YaBB_Board ne "")
		{
		my($yabbnewthreadid, $newthreadcount, $newmessagecount, $oldmessagecount, $oldmessagestate, $line, $mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate, $YaBB_User, $YaBB_User_Email);
		require 'crlib.pl';
		&ReadUserDBInfo();
		&InitUserFieldVars();
		# If the user provided YaBB-account information, use it.
		if ($userdata{$CurrentUser}->{'YaBB_UserName'} ne "")
			{
			$YaBB_User = $userdata{$CurrentUser}->{'YaBB_UserName'};
			if ($userdata{$CurrentUser}->{'YaBB_UserEmail'} ne "")
				{
				$YaBB_User_Email = $userdata{$CurrentUser}->{'YaBB_UserEmail'};
				}
			else
				{
				$YaBB_User_Email = $CConfig{'YaBB_User_Email'};
				}
			}
		else
			{
			$YaBB_User = $CConfig{'YaBB_User'};
			$YaBB_User_Email = $CConfig{'YaBB_User_Email'};
			}
		&BasicDateVars(time);
		my $YaBB_Time = "$TwoDigitMonth/$TwoDigitDay/$TwoDigitYear  $TwoDigitHour:$Minute:$Second";
		# Check if a thread ID exists for the newsitem. Create one if necessary.
		if( $CustomField_YaBB_ID eq '' || !(-e "$CConfig{'YaBB_Abs_Path'}/Messages/$CustomField_YaBB_ID.txt")) 
			{
			$yabbnewthreadid = time;
			my $i=0;
			if (-e "$CConfig{'YaBB_Abs_Path'}/Messages/$yabbnewthreadid.txt") 
				{
				while (-e "$CConfig{'YaBB_Abs_Path'}/Messages/$yabbnewthreadid.txt")
					{
					++$i;
					}
				$yabbnewthreadid="$yabbnewthreadid$i";
				}
			$CustomField_YaBB_ID = "$yabbnewthreadid";
			}
		else 
			{ 
			$yabbnewthreadid = ''; 
			}
		# If this is a new thread, create it
		if($yabbnewthreadid) 
			{
			# This is a new thread. Create new thread data to boardindex.
			open(YABB_FILE, "+<$CConfig{'YaBB_Abs_Path'}/Boards/$CustomField_YaBB_Board.txt") || $addon->fatalError("101 An error has occured!: Unable to open $CustomField_YaBB_Board.txt");
			if ($UseFlock) 
				{
				flock(YABB_FILE, 2) || $addon->fatalError("Could not obtain an exclusive lock on file $CustomField_YaBB_Board.txt"); 
				}
			seek YABB_FILE, 0, 0;
			open(TEMP, "+>$CConfig{'YaBB_Abs_Path'}/Boards/$CustomField_YaBB_Board.txt.temp") || $addon->fatalError("102 An error has occured!: Unable to open $CConfig{'YaBB_Abs_Path'}/Boards/$CustomField_YaBB_Board.txt.temp");
			my $buffer;
			while( read(YABB_FILE,$buffer,1024) ) 
				{
				print TEMP $buffer; 
				}
			seek TEMP, 0, 0;
			truncate YABB_FILE, 0;
			seek YABB_FILE, 0, 0;
			print YABB_FILE qq~$CustomField_YaBB_ID|$in{'Subject'}|$YaBB_User|$YaBB_User_Email|$YaBB_Time|0|$YaBB_User|xx|0\n~;
			while( read(TEMP,$buffer,1024) ) 
				{
				print YABB_FILE $buffer;
				}
			close(TEMP);
			if (-e "$CConfig{'YaBB_Abs_Path'}/Boards/$CustomField_YaBB_Board.txt.temp") 
				{
				unlink("$CConfig{'YaBB_Abs_Path'}/Boards/$CustomField_YaBB_Board.txt.temp"); 
				}
			close(YABB_FILE);
			# This is a new thread. Create a new thread file.
			open(YABB_FILE, ">$CConfig{'YaBB_Abs_Path'}/Messages/$CustomField_YaBB_ID.txt") || $addon->fatalError("103 An error has occured!: Unable to open $CustomField_YaBB_ID.txt");
			if ($UseFlock) 
				{
				flock(YABB_FILE, 2) || $addon->fatalError("Could not obtain an exclusive lock on file $CustomField_YaBB_ID.txt"); 
				}
			my $YText = $in{'Text'};
			$YText =~ s/<br>/\n/ig;
			$YText =~ s/[\n]/[br]/ig;
			$YText =~ s/[\r]//ig;
			$YText =~ s/<hr>/[hr]/ig;
			$YText =~ s/\<a href="mailto:([^">].*?)"\>([^<].*?)\<\/a\>/\[email\]$1\[\/email\]/ig;
			$YText =~ s/<a href="([^"].*?)"([^>].*?)?\>([^<].*?)<\/a>/\[url=$1\]$3\[\/url\]/ig;
			$YText =~ s/<img src="([^"].*?)"([^>].*?)?>/\[img\]$1 \[\/img\]/ig;
			$YText =~ s/<a name([^>].*?)>([^<].*?)<\/a>/$2/ig;
			$YText =~ s/<b>/[b]/ig;
			$YText =~ s/<\/b>/[\/b]/ig;
			$YText =~ s/<i>/[i]/ig;
			$YText =~ s/<\/i>/[\/i]/ig;
			$YText =~ s/<u>/[u]/ig;
			$YText =~ s/<\/u>/[\/u]/ig;
			$YText =~ s/<ol([^>].*?)?>/[list]/ig;
			$YText =~ s/<ul([^>].*?)?>/[list]/ig;
			$YText =~ s/<li([^>].*?)?>/[*]/ig;
			$YText =~ s/<\/ol>/[\/list]/ig;
			$YText =~ s/<\/ul>/[\/list]/ig;
			$YText =~ s/<code([^>].*?)?>//ig;
			$YText =~ s/<\/code>//ig;
			$YText =~ s/<tt([^>].*?)?>//ig;
			$YText =~ s/<\/tt>//ig;
			$YText =~ s/<font([^>].*?)>//ig;
			$YText =~ s/<\/font>//ig;
			$YText =~ s/<table([^>].*?)>/[table]/ig;
			$YText =~ s/<\/table>/[\/table]/ig;
			$YText =~ s/<tr([^>].*?)?>/\[tr\]/ig;
			$YText =~ s/<th([^>].*?)?>/[td]/ig;
			$YText =~ s/<td([^>].*?)?>/[td]/ig;
			$YText =~ s/<\/tr>/[\/tr]/ig;
			$YText =~ s/<\/td>/[\/td]/ig;
			$YText =~ s/<\/th>/[\/td]/ig;
			$YText =~ s/<([^>].*?)?>//ig;
			print YABB_FILE qq~$in{'Subject'}|$YaBB_User|$YaBB_User_Email|$YaBB_Time|$YaBB_User|xx|0||$YText||\n~;
			close(YABB_FILE);
			$newthreadcount = $newmessagecount = 1;
			}
		# This thread exists..
		else 
			{
			# This is an old thread. Modify thread data in boardindex.
			open(YABB_FILE, "+<$CConfig{'YaBB_Abs_Path'}/Boards/$CustomField_YaBB_Board.txt") || $addon->fatalError("201 An error has occured!: Unable to open $CustomField_YaBB_Board.txt");
			if ($UseFlock) 
				{
				flock(YABB_FILE, 2) || $addon->fatalError("Could not obtain an exclusive lock on file $CustomField_YaBB_Board.txt"); 
				}
			seek YABB_FILE, 0, 0;
			open(TEMP, "+>$CConfig{'YaBB_Abs_Path'}/Boards/$CustomField_YaBB_Board.txt.temp") || $addon->fatalError("202 An error has occured!: Unable to open $CConfig{'YaBB_Abs_Path'}/Boards/$CustomField_YaBB_Board.txt.temp");
			seek TEMP, 0, 0;
			my $buffer;
			while( read(YABB_FILE,$buffer,1024) ) 
				{
				print TEMP $buffer;
				}
			truncate YABB_FILE, 0;
			seek YABB_FILE, 0, 0;
			seek TEMP, 0, 0;
			while( $line = <TEMP> ) 
				{
				my ($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split(/\|/,$line);
				if ($mnum == $CustomField_YaBB_ID)
					{
					$oldmessagecount = $mreplies;
					$oldmessagestate = $mstate;
					}
				}
			print YABB_FILE qq~$CustomField_YaBB_ID|$in{'Subject'}|$YaBB_User|$YaBB_User_Email|$YaBB_Time|$oldmessagecount|$YaBB_User|xx|$oldmessagestate~;
			seek TEMP, 0, 0;
			while( $line = <TEMP> ) 
				{
				my ($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split(/\|/,$line);
				if ($mnum != $CustomField_YaBB_ID)
					{
					print YABB_FILE $line;
					}
				}
			close(TEMP);
			if (-e "$CConfig{'YaBB_Abs_Path'}/Boards/$CustomField_YaBB_Board.txt.temp") 
				{
				unlink("$CConfig{'YaBB_Abs_Path'}/Boards/$CustomField_YaBB_Board.txt.temp"); 
				}
			close(YABB_FILE);
			# This is an old thread. Modify the first post in this thread.
			open(YABB_FILE, "+<$CConfig{'YaBB_Abs_Path'}/Messages/$CustomField_YaBB_ID.txt") || $addon->fatalError("203 An error has occured!: Unable to open $CustomField_YaBB_ID.txt");
			if ($UseFlock) 
				{
				flock(YABB_FILE, 2) || $addon->fatalError("Could not obtain an exclusive lock on file $CustomField_YaBB_ID.txt"); 
				}
			seek YABB_FILE, 0, 0;
			open(TEMP, "+>$CConfig{'YaBB_Abs_Path'}/Messages/$CustomField_YaBB_ID.txt.temp") || $addon->fatalError("204 An error has occured!: Unable to open $CustomField_YaBB_ID.txt.temp");
			seek TEMP, 0, 0;
			while( read(YABB_FILE,$buffer,1024) ) 
				{
				print TEMP $buffer;
				}
			truncate YABB_FILE, 0;
			seek YABB_FILE, 0, 0;
			my $YaBB_Modified = "<br><br>[Modified $YaBB_Time by $YaBB_User]";
			my $YText = $in{'Text'};
			$YText =~ s/<br>/\n/ig;
			$YText =~ s/[\n]/[br]/ig;
			$YText =~ s/[\r]//ig;
			$YText =~ s/<hr>/[hr]/ig;
			$YText =~ s/\<a href="mailto:([^">].*?)"\>([^<].*?)\<\/a\>/\[email\]$1\[\/email\]/ig;
			$YText =~ s/<a href="([^"].*?)"([^>].*?)?\>([^<].*?)<\/a>/\[url=$1\]$3\[\/url\]/ig;
			$YText =~ s/<img src="([^"].*?)"([^>].*?)?>/\[img\]$1 \[\/img\]/ig;
			$YText =~ s/<a name([^>].*?)>([^<].*?)<\/a>/$2/ig;
			$YText =~ s/<b>/[b]/ig;
			$YText =~ s/<\/b>/[\/b]/ig;
			$YText =~ s/<i>/[i]/ig;
			$YText =~ s/<\/i>/[\/i]/ig;
			$YText =~ s/<u>/[u]/ig;
			$YText =~ s/<\/u>/[\/u]/ig;
			$YText =~ s/<ol([^>].*?)?>/[list]/ig;
			$YText =~ s/<ul([^>].*?)?>/[list]/ig;
			$YText =~ s/<li([^>].*?)?>/[*]/ig;
			$YText =~ s/<\/ol>/[\/list]/ig;
			$YText =~ s/<\/ul>/[\/list]/ig;
			$YText =~ s/<code([^>].*?)?>//ig;
			$YText =~ s/<\/code>//ig;
			$YText =~ s/<tt([^>].*?)?>//ig;
			$YText =~ s/<\/tt>//ig;
			$YText =~ s/<font([^>].*?)>//ig;
			$YText =~ s/<\/font>//ig;
			$YText =~ s/<table([^>].*?)>/[table]/ig;
			$YText =~ s/<\/table>/[\/table]/ig;
			$YText =~ s/<tr([^>].*?)?>/\[tr\]/ig;
			$YText =~ s/<th([^>].*?)?>/[td]/ig;
			$YText =~ s/<td([^>].*?)?>/[td]/ig;
			$YText =~ s/<\/tr>/[\/tr]/ig;
			$YText =~ s/<\/td>/[\/td]/ig;
			$YText =~ s/<\/th>/[\/td]/ig;
			$YText =~ s/<([^>].*?)?>//ig;
			print YABB_FILE qq~$in{'Subject'}|$YaBB_User|$YaBB_User_Email|$mdate|$YaBB_User|xx|0||$YText$YaBB_Modified||\n~;
			seek TEMP, 0, 0;
			my $new_count = 0;
			while( $line = <TEMP> ) 
				{
				if($new_count != 0)
					{
					print YABB_FILE $line;
					}
				$new_count++;
				}
			close(TEMP);
			if (-e "$CConfig{'YaBB_Abs_Path'}/Messages/$CustomField_YaBB_ID.txt.temp") 
				{
				unlink("$CConfig{'YaBB_Abs_Path'}/Messages/$CustomField_YaBB_ID.txt.temp"); 
				}
			close(YABB_FILE);
			$newthreadcount = $newmessagecount = 0;
			}

		# Replace last poster with the selected username.
		# If the board is empty, this file does not exist. Create it.

		open(YABB_FILE, "+>$CConfig{'YaBB_Abs_Path'}/Boards/$CustomField_YaBB_Board.poster") || $addon->fatalError("301 An error has occured!: Unable to open $CustomField_YaBB_Board.poster");
		if ($UseFlock) 
			{
			flock(YABB_FILE, 2) || $addon->fatalError("Could not obtain an exclusive lock on file $CustomField_YaBB_Board.poster"); 
			}
		truncate YABB_FILE, 0;
		seek YABB_FILE, 0, 0;
		print YABB_FILE qq~$YaBB_User~;
		close(YABB_FILE);

		# Update postcount in user profile if user exists and the thread is new
		if ((-e "$CConfig{'YaBB_Abs_Path'}/Members/$YaBB_User.dat")  && ($newthreadcount == 1))
			{
			open(YABB_FILE, "+<$CConfig{'YaBB_Abs_Path'}/Members/$YaBB_User.dat") || $addon->fatalError("302 An error has occured!: Unable to open $YaBB_User.dat");
			if ($UseFlock) 
				{
				flock(YABB_FILE, 2) || $addon->fatalError("Could not obtain an exclusive lock on file $YaBB_User.dat"); 
				}
			seek YABB_FILE, 0, 0;
			open(TEMP, "+>$CConfig{'YaBB_Abs_Path'}/Members/$YaBB_User.dat.temp") || $addon->fatalError("303 An error has occured!: Unable to open $YaBB_User.dat.temp");
			seek TEMP, 0, 0;
			while( read(YABB_FILE,$buffer,1024) ) 
				{
				print TEMP $buffer;
				}
			truncate YABB_FILE, 0;
			seek YABB_FILE, 0, 0;
			seek TEMP, 0, 0;
			my $new_count = 0;
			while( $line = <TEMP> ) 
				{
				if($new_count != 6)
					{
					print YABB_FILE $line;
					}
				else
					{
					chomp $line;
					$line = "$line" + 1;
					print YABB_FILE qq~$line\n~;
					}
				$new_count++;
				}
			close(YABB_FILE);
			close(TEMP);
			if (-e "$CConfig{'YaBB_Abs_Path'}/Members/$YaBB_User.dat.temp") 
				{
				unlink("$CConfig{'YaBB_Abs_Path'}/Members/$YaBB_User.dat.temp"); 
				}
			}

		# Modify boardtotals to reflect new thread/post counts.
		open(YABB_FILE, "+<$CConfig{'YaBB_Abs_Path'}/Boards/$CustomField_YaBB_Board.ttl");
		if ($UseFlock) 
			{
			flock(YABB_FILE, 2) || $addon->fatalError("Could not obtain an exclusive lock on file $CustomField_YaBB_Board.ttl"); 
			}
		my $line = <YABB_FILE>;
		my ($TTL_threadcount, $TTL_messagecount, $TTL_lastposttime, $TTL_lastposter) = split(/\|/,$line);
		$TTL_threadcount += $newthreadcount;
		$TTL_messagecount += $newmessagecount;
		$TTL_lastposttime = "$YaBB_Time";
		$TTL_lastposter = "$YaBB_User";
		truncate YABB_FILE, 0;
		seek YABB_FILE, 0, 0;
		print YABB_FILE qq~$TTL_threadcount|$TTL_messagecount|$TTL_lastposttime|$TTL_lastposter~;
		close(YABB_FILE);
		my $DATA_views;
		if (-e "$CConfig{'YaBB_Abs_Path'}/Messages/$CustomField_YaBB_ID.data")
			{
			open(YABB_FILE, "+<$CConfig{'YaBB_Abs_Path'}/Messages/$CustomField_YaBB_ID.data");
			if ($UseFlock) 
				{
				flock(YABB_FILE, 2) || $addon->fatalError("Could not obtain an exclusive lock on file $CustomField_YaBB_ID.data"); 
				}
			($DATA_views, $DATA_lastposter) = split(/\|/,<YABB_FILE>);
			truncate YABB_FILE,0;
			}
		else
			{
			open(YABB_FILE, "+>$CConfig{'YaBB_Abs_Path'}/Messages/$CustomField_YaBB_ID.data");
			if ($UseFlock) 
				{
				flock(YABB_FILE, 2) || $addon->fatalError("Could not obtain an exclusive lock on file $CustomField_YaBB_ID.data"); 
				}
			}
		seek YABB_FILE, 0, 0;
		print YABB_FILE "$DATA_views|$YaBB_User";
		close(YABB_FILE);
		}
	}

sub YaBB_ModifyNews_Delete 
	{
	if (($CustomField_YaBB_Board ne "") && ($in{"del-$newsid"} eq 'del') && ($in{"YaBB_Del-$newsid"} eq 'delete'))
		{
		# Count thread posts and remove the thread from boardindex 
		my ($oldmessagecount, $buffer, $line, $mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate, $YaBB_User, $YaBB_User_Email);
		require 'crlib.pl';
		&ReadUserDBInfo();
		&InitUserFieldVars();
		# If the user provided YaBB-account information, use it.
		if ($userdata{$CurrentUser}->{'YaBB_UserName'} ne "")
			{
			$YaBB_User = $userdata{$CurrentUser}->{'YaBB_UserName'};
			if ($userdata{$CurrentUser}->{'YaBB_UserEmail'} ne "")
				{
				$YaBB_User_Email = $userdata{$CurrentUser}->{'YaBB_UserEmail'};
				}
			else
				{
				$YaBB_User_Email = $CConfig{'YaBB_User_Email'};
				}
			}
		else
			{
			$YaBB_User = $CConfig{'YaBB_User'};
			$YaBB_User_Email = $CConfig{'YaBB_User_Email'};
			}
		open(YABB_FILE, "+<$CConfig{'YaBB_Abs_Path'}/Boards/$CustomField_YaBB_Board.txt") || $addon->fatalError("401 An error has occured!: Unable to open $CustomField_YaBB_Board.txt");
		if ($UseFlock) 
			{
			flock(YABB_FILE, 2) || $addon->fatalError("Could not obtain an exclusive lock on file $CustomField_YaBB_Board.txt"); 
			}
		seek YABB_FILE, 0, 0;
		open(TEMP, "+>$CConfig{'YaBB_Abs_Path'}/Boards/$CustomField_YaBB_Board.txt.temp") || $addon->fatalError("402 An error has occured!: Unable to open $CConfig{'YaBB_Abs_Path'}/Boards/$CustomField_YaBB_Board.txt.temp");
		seek TEMP, 0, 0;
		while( read(YABB_FILE,$buffer,1024) ) 
			{
			print TEMP $buffer;
			}
		truncate YABB_FILE, 0;
		seek YABB_FILE, 0, 0;
		seek TEMP, 0, 0;
		while( $line = <TEMP> ) 
			{
			($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split(/\|/,$line);
			if ($mnum != $CustomField_YaBB_ID)
				{
				print YABB_FILE $line;
				}
			else		
				{
				$mreplies++;
				$oldmessagecount = $mreplies;
				}
			}
		close(TEMP);
		if (-e "$CConfig{'YaBB_Abs_Path'}/Boards/$CustomField_YaBB_Board.txt.temp") 
			{
			unlink("$CConfig{'YaBB_Abs_Path'}/Boards/$CustomField_YaBB_Board.txt.temp"); 
			}
		close(YABB_FILE);

		# Replace last poster with N/A
		open(YABB_FILE, "+<$CConfig{'YaBB_Abs_Path'}/Boards/$CustomField_YaBB_Board.poster") || $addon->fatalError("403 An error has occured!: Unable to open $CustomField_YaBB_Board.poster");
		if ($UseFlock) 
			{
			flock(YABB_FILE, 2) || $addon->fatalError("Could not obtain an exclusive lock on file $CustomField_YaBB_Board.poster"); 
			}
		truncate YABB_FILE, 0;
		seek YABB_FILE, 0, 0;
		print YABB_FILE qq~N/A~;
		close(YABB_FILE);
	
		# Edit board totals to reflect changed thread/post count
		open(YABB_FILE, "+<$CConfig{'YaBB_Abs_Path'}/Boards/$CustomField_YaBB_Board.ttl");
		if ($UseFlock) 
			{
			flock(YABB_FILE, 2) || $addon->fatalError("Could not obtain an exclusive lock on file $CustomField_YaBB_Board.ttl"); 
			}
		my $tmp = <YABB_FILE>;
		chomp $tmp;
		my ($TTL_threadcount, $TTL_messagecount, $TTL_lastposttime, $TTL_lastposter) = split(/\|/,$tmp);
		$TTL_threadcount--;
		$TTL_messagecount -= $oldmessagecount;
		$TTL_lastposttime = "N/A";
		$TTL_lastposter = "N/A";
		truncate YABB_FILE, 0;
		seek YABB_FILE, 0, 0;
		print YABB_FILE qq~$TTL_threadcount|$TTL_messagecount|$TTL_lastposttime|$TTL_lastposter~;
		close(YABB_FILE);

		# Update postcount in user profile if user exists
		if ((-e "$CConfig{'YaBB_Abs_Path'}/Members/$YaBB_User.dat") && (-e "$CConfig{'YaBB_Abs_Path'}/Messages/$CustomField_YaBB_ID.txt"))
			{
			open(YABB_FILE, "<$CConfig{'YaBB_Abs_Path'}/Messages/$CustomField_YaBB_ID.txt") || $addon->fatalError("404 An error has occured!: Unable to open $CustomField_YaBB_ID.txt");
			my $line;
			my $YaBB_UPP_tmp = 0;
			while ($line = <YABB_FILE>)
				{
				my ($Y_tmp1,$Y_User,$Y_tmp2,$Y_tmp3,$Y_tmp4,$Y_tmp5,$Y_tmp6,$Y_tmp7,$Y_tmp8,$Y_tmp9,$Y_tmp10)  = split(/\|/,$line);
				if ($Y_User eq $YaBB_User)
					{
					$YaBB_UPP_tmp++;
					}
				}
			close (YABB_FILE);
			open(YABB_FILE, "+<$CConfig{'YaBB_Abs_Path'}/Members/$YaBB_User.dat") || $addon->fatalError("405 An error has occured!: Unable to open $YaBB_User.dat");
			if ($UseFlock) 
				{
				flock(YABB_FILE, 2) || $addon->fatalError("Could not obtain an exclusive lock on file $YaBB_User.dat"); 
				}
			seek YABB_FILE, 0, 0;
			open(TEMP, "+>$CConfig{'YaBB_Abs_Path'}/Members/$YaBB_User.dat.temp") || $addon->fatalError("406 An error has occured!: Unable to open $YaBB_User.dat.temp");
			seek TEMP, 0, 0;
			while( read(YABB_FILE,$buffer,1024) ) 
				{
				print TEMP $buffer;
				}
			truncate YABB_FILE, 0;
			seek YABB_FILE, 0, 0;
			seek TEMP, 0, 0;
			my $new_count = 0;
			while( $line = <TEMP> ) 
				{
				if($new_count != 6)
					{
					print YABB_FILE $line;
					}
				else
					{
					chomp $line;
					$line = "$line" - $YaBB_UPP_tmp;
					print YABB_FILE qq~$line\n~;
					}
				$new_count++;
				}
			close(YABB_FILE);
			close(TEMP);
			if (-e "$CConfig{'YaBB_Abs_Path'}/Members/$YaBB_User.dat.temp") 
				{
				unlink("$CConfig{'YaBB_Abs_Path'}/Members/$YaBB_User.dat.temp"); 
				}
			}

		# Remove thread files
		if (-e "$CConfig{'YaBB_Abs_Path'}/Messages/$CustomField_YaBB_ID.txt") 
			{
			unlink("$CConfig{'YaBB_Abs_Path'}/Messages/$CustomField_YaBB_ID.txt");
			}
		if (-e "$CConfig{'YaBB_Abs_Path'}/Messages/$CustomField_YaBB_ID.mail") 
			{
			unlink("$CConfig{'YaBB_Abs_Path'}/Messages/$CustomField_YaBB_ID.mail");
			}
		if (-e "$CConfig{'YaBB_Abs_Path'}/Messages/$CustomField_YaBB_ID.data") 
			{
			unlink("$CConfig{'YaBB_Abs_Path'}/Messages/$CustomField_YaBB_ID.data");
			}
		}
	}

1;

=head1 YaBB comments

=head2 Description & Usage

This addon enables you to use YaBB forum for news comments. 
As you submit/modify news you will notice some new fields in the form. The one called 'YaBB_ID#' you don't normally need to use. The second 'YaBB Board' is there because Coranto's dropdown boxes are not flexible enough and the addon uses Coranto's database to store information.
If the newsitem has a thread you will not see the board selection dropdown box, but if you have selected not to create a thread for the newsitem when you created it, you may do so on the modify page by selecting a board for the thread.

YaBB-files are accessed directly, so you will have to provide some settings in 'Change Settings'. 
When you submit a newsitem, a thread is automatically created in the chosen board. 
Modifying a news item will modify the corresponding post and include a notice of modification in the last line of the post. 
Deleting a newsitem will also delete the entire thread, if you so choose.

NOTE! If you remove comment threads directly from YaBB, you will end up having a broken comments-link for the newsitem.
Modifying the newsitem will automatically create a new thread to replace the missing one.

=head2 Setup & Configuration

The settings are simple enough in the 'Change Settings' area. The 'YaBB Board' is the default value for the board selection on submit page (leave empty to default to not creating a new thread).
If you do not want to have the poster appear as a guest, you can create an account in YaBB with the same username (max 18 characters, no spaces and special characters).
You can also to make 2 new userfields manually, if you want to use individual YaBB-accounts for each user. 
Name them "YaBB_UserName" and "YaBB_UserEmail" (without the quotes). The values in 'Change Settings' will be used if the user does not provide YaBB-account information.

If you want to show the count of comments for any particular newsitem, here's how to do it: 

	1. Configure and upload the included replies.pl to your Coranto folder.
	2. Create a profile which creates an shtml-file (e.g. news.shtml) and replace news.txt with it on your news page.
	3. Edit your news style to include (replacing path to replies.pl with your path):

	<If: Field: CustomField_YaBB_ID>&nbsp;&nbsp;-&nbsp;&nbsp;<a href="
	<PerlCode>
	$newshtml .= "$CConfig{'YaBB_Path'}/YaBB.pl?board=$CustomField_YaBB_Board\&action=display&num=";
	</PerlCode><Field: CustomField_YaBB_ID>" target=_blank>Comments <!--#config errmsg="(N/A)" --><!--#include virtual="/cgi-bin/coranto/replies.pl?<Field: CustomField_YaBB_ID>,<Field: CustomField_YaBB_Board>"--></a></If>

If you don't care about the replycount, you can simply edit your news style to include:

	<If: Field: CustomField_YaBB_ID><a href="<PerlCode>
	$newshtml .= "$CConfig{'YaBB_Path'}/YaBB.pl?board=$CustomField_YaBB_Board\&action=display&num=";
	</PerlCode><Field: CustomField_YaBB_ID>" target=_blank>Comments</a></If>
